@echo off
REM Windows 7 Dienste Konfigtool - published under GNU GPL
REM Copyright (c) Andreas Hecht
REM Version 1.1 / 30.01.2009
REM Homepage: http://www.netbrain.de
REM This program is free software; you can redistribute it and/or modify it under
REM the terms of the GNU General Public License as published by the Free Software Foundation;
REM either version 2 of the License, or (at your option) any later version.
REM This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
REM without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
REM See the GNU General Public License for more details.
REM Tested on Vista Ultimate SP1

SET ProgVersion=1.1   Copyright (c) 2009
SET ProgDesign= Andreas Hecht
SET ProgName=Windows 7 Dienste Konfigtool.cmd
SET Homepage=http://www.the-netbrain.de

REM ******************************************************************
REM Hat sich das Tool selber aufgerufen...
if #%1#==#servicecheck# goto servicecheck
if #%1#==#servicesave# goto servicesave
REM ******************************************************************

REM ******************************************************************
REM Prfen der Betriebssystemversion und ob entsprechende Rechte vorhanden sind
if not errorlevel 1 goto CheckAdmin
ver | find /i "Windows [Version 7.3.7000.0.">nul
cls
echo Windows 7 Dienste Konfigtool - published under GNU GPL
echo Version: %ProgVersion% - %ProgDatum%
echo.
echo Info: Tool ist nur fr Windows Seven 7.0.x geeignet...
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end
:CheckAdmin
reg add HKLM\Software /v AdminCheck /t REG_SZ /d OK>NUL
if errorlevel 1 goto Show_CheckAdmin
reg delete HKLM\Software /v AdminCheck /f>NUL
REM ******************************************************************

echo "%CMDCMDLINE%"|"find" /i "/C">NUL
if errorlevel 1 goto cmdStart
for /f "eol= tokens=2*" %%i in (%CMDCMDLINE%) do Set ProgPfad=%%~dj%%~pj
Set ProgName=%ProgPfad%%ProgName%
cd /d %ProgPfad%

:cmdStart
if not exist "%ProgName%" goto Show_ProgName

if not #%1#==## goto setfileconfig

cls
echo.
echo   	    Windows 7 Dienste Konfigtool - published under GNU GPL
echo   ___________________________________________________________________________
echo.
echo    V%ProgVersion% - %ProgDesign% - %Homepage%
echo   ---------------------------------------------------------------------------
echo.

set SaveConfig=NO
set Datum=%date::=%
SET BackupFile=ServiceBackup_%Datum%.txt
if not exist "%ProgPfad%%BackupFile%" goto :BFilenotExist
echo INFO: Sicherungsdatei %BackupFile% ist schon vorhanden...
echo       Wenn Sie eine Funktion ausfhren, wird die alte Sicherungsdatei
echo       berschrieben.
echo.
:BFilenotExist

REM ******************************************************************
:Menu
echo.
echo                -= Auswahl / Overview =-
echo.
echo   Bitte waehlen sie einen Punkt aus, den sie ausfuehren moechten:
echo   ***************************************************************
echo.
echo             (1) Default Windows 7 Ultimate
echo.
echo             (2) Workstation ohne Netzwerk (unsichere Dienste beendet)
echo.
echo             (S) Bestehende Konfiguration sichern
echo             (R) Sicherung zurueckspielen
echo.   
echo   ----------------------------------------------------------------
echo.
set /P key= Bitte whlen Sie / Please choose: [1],[2],[R] oder [S], [Q]uit? 
if /I #%key%#==#Q# goto :End
if /I #%key%#==#S# (
		Set configfile=Default_Seven.txt
		SET BackupFile=ServiceBackup_%Computername%_%Datum%.txt
		Set SaveConfig=YES
		goto :service
		)
if /I #%key%#==#1# (
		Set configfile=Default_Seven.txt
		goto :service
		)
if /I #%key%#==#2# (
		Set configfile=Workstation.txt
		goto :service
		)
if /I #%key%#==#R# (
		Set configfile=ServiceBackup_%Computername%_%Datum%.txt
		goto :service
		)
echo Es wurde eine ungltige Taste gedrckt...
goto end
REM ******************************************************************

REM ******************************************************************
REM Hier wird die Konfigurationsdatei eingelesen
:service
if NOT #%SaveConfig%#==#YES# goto startservice
if NOT exist "%ProgPfad%%Backupfile%" goto startservice
echo.
echo Die Sicherungsdatei %Backupfile% ist schon vorhanden!
echo Soll die Datei neu erstellt werden?
set /P key= [J]a oder [Q]uit?
if /I #%key%#==#Q# goto :End
:startservice
if not exist "%ProgPfad%%configfile%" goto configfilenotfound
echo Backupfile fr: %Computername%>"%ProgPfad%%BackupFile%"
for /f "eol=; skip=1 tokens=1,2,3*" %%i in (%configfile%) do call "%ProgName%" servicecheck %%i %%j
if #%SaveConfig%#==#YES# Goto Show_SaveConfig
goto Show_SetConfig
goto end
REM ******************************************************************

:setfileconfig
cls
echo Windows 7 Dienste Konfigtool
echo.
echo Setze die Einstellungen ber %1
echo.
if not exist "%1" goto filenotfond
set configfile=%1
set Datum=%date::=%
SET BackupFile=ServiceBackup_%Datum%.txt
If /I #%BackupFile%#==#%1# Set BackupFile=ServiceBackup02_%Datum%.txt
goto service
goto end

REM ******************************************************************
REM Auslesen der aktuellen Einstellungen und speichern der Konfiguration
:servicecheck
echo Bearbeite Service: %2
for /f "eol=: skip=4 tokens=1,2,3*" %%i in ('sc qc %2') do call "%ProgName%" servicesave %2 %3 %%i %%k "%%l" 
goto end

:servicesave
if not #%4#==#START_TYPE# Goto end
if /I #%5#==#0# Set StartType=BOOT
if /I #%5#==#1# Set StartType=SYSTEM
if /I #%5#==#2# Set StartType=AUTO
if /I %6=="AUTO_START  (DELAYED)" Set StartType=DELAYED-AUTO
if /I #%5#==#3# Set StartType=DEMAND
if /I #%5#==#4# Set StartType=DISABLED
echo %2;%StartType%>>"%ProgPfad%%BackupFile%"
if #%SaveConfig%#==#YES# Goto end
if /I #%StartType%#==#%3# echo                    gleiche Einstellung...
if /I #%StartType%#==#%3# goto end
echo               von: %StartType% auf %3
sc config %2 start= %3>nul
if errorlevel 1 goto Show_ErrorSC
goto end
REM ******************************************************************

:configfilenotfound
echo.
echo Fehler:
echo -------
echo.
echo Die angegebene Datei %configfile% wurde nicht gefunden.
echo Haben Sie das Programm aus dem Installationsverzeichnis gestartet?
echo.
goto end

:filenotfond
echo.
echo Fehler:
echo -------
echo.
echo Die angegebene Datei %1 wurde nicht gefunden. Bitte geben Sie einen 
echo Dateinamen an, der auch vorhanden ist. 
echo Die Einstellungen werden anhand der Datei vorgenommen.
echo.
goto end

:Show_SaveConfig
echo.
echo.
echo Die aktulle Konfiguration wurde gesichert als
echo %BackupFile%
echo Durch den erneuten Aufruf des Programmes und
echo betaetigen der Taste [R] koennen Sie die
echo Sicherung jederzeit wieder einspielen.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_SetConfig
echo.
echo Die alte Konfiguration wurde gesichert als:
echo %BackupFile%
echo Durch den Aufruf von:
echo "service_config.cmd %BackupFile%"
echo knnen Sie diese Einstellungen wieder hestellen.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_CheckAdmin
cls
echo Windows 7 Dienste Konfigtool - published under GNU GPL
echo Version: %ProgVersion% - %ProgDatum%
echo.
echo Damit das Tool richtig arbeitet mssen Sie es als Administrator
echo ausfhren.
echo Klicken Sie die Datei mit der rechten Maustaste an und waehlen
echo Sie aus dem Kontextmen den Eintrag "Als Administrator ausfhren"
echo aus.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_ProgName
cls
echo Windows 7 Dienste Konfigtool
echo Version: %ProgVersion% - %ProgDatum%
echo.
echo Sie haben den Programmnamen gendert.
echo.
echo Damit das Programm luft mssen Sie auch die Variable:
echo ProgName anpassen.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_ErrorSC
echo.
echo Bei setzten der Startart mit SC ist ein Fehler aufgetreten
echo.
echo Beenden mit einer Taste...
pause>NUL
exit

:End
